'                                  TRAVECON.BAS
'
'          Risoluzione di uno schema di trave continua
'
'                                                            rev. 01.90

DECLARE SUB FCOPY (SCR!, DENS!, F!)
DECLARE SUB ModGraf (Scheda!)

    '       PROGRAMMA PRINCIPALE
    '
    KEY OFF
    OPTION BASE 1
    DIM DL(16), B1(16), H1(16), B2(16), H2(16), Q(16), MN(17)
    DIM ZI(16), W(16), MS(16), MD(16), TS(16), TD(16)
    DIM A(17), B(17), C(17), X(5), M(5), T(5)
    DIM UF(5), UR(60), UC(60), UL(60)
    '
    CLS
    LOCATE 3, 1
    PRINT "                    TRAVECON"
    PRINT
    PRINT "      Risoluzione di una trave continua - rev. 01.90"
    PRINT
    PRINT
    PRINT
    PRINT "      Quale sistema di misura vuoi utilizzare ?"
    PRINT "         1 = sistema tecnico"
    PRINT "         2 = sistema internazionale           ";
    INPUT MI
    PRINT
    PRINT "      Dove vuoi inviati i risultati ?"
    PRINT "         indica: CON = schermo"
    PRINT "                 PRN = stampante"
    PRINT "         oppure indica il nome di un file     ";
    INPUT FOut$
    FOut$ = UCASE$(FOut$)
    PRINT
    PRINT "      Dove vuoi inviati i diagrammi ?"
    PRINT "         indica: CON = schermo"
    PRINT "                 PRN = stampante"
    PRINT "         oppure indica il nome di un file     ";
    INPUT DiagOut$
    DiagOut$ = UCASE$(DiagOut$)
    '
    OPEN "O", #2, FOut$
    IF DiagOut$ <> FOut$ AND DiagOut$ <> "CON" THEN
       NDiag = 3
       OPEN "O", #3, DiagOut$
    ELSE
       NDiag = 2
    END IF
    '
    '      definizioni iniziali per ingresso dati
    GOSUB 7800
    VH = 0
    IG = 0
    IQ = 0
    IM = 0
    UZ = 5
    UH = 1
    '      ingresso dati
400 DO WHILE UH <= UZ
       SELECT CASE UH
          CASE 1
             GOSUB 1000
          CASE 2
             GOSUB 2000
          CASE 3
             GOSUB 3000
          CASE 4
             GOSUB 4000
          CASE 5
             GOSUB 5000
       END SELECT
       '
       UH = UH + UU
       IF UH = 0 THEN UH = 1
    LOOP
    '      memorizzazione valori su disco
    IF O$ = "SI" THEN GOSUB 10000
    '      risoluzione dello schema
    GOSUB 11000
    '      stampa dati
    IF FOut$ = "CON" THEN CLS
    GOSUB 12000
    '      stampa risultati
    GOSUB 13000
    '
    CALL ModGraf(SCR)
    IF SCR = 0 THEN
       PRINT
       PRINT "Impossibile visualizzare i diagrammi"
    ELSE
       IF DiagOut$ <> "CON" AND SCR <> 3 THEN
          SCR = 2
          SCREEN SCR
       END IF
       GOSUB 14000       ' visualizzazione diagrammi
    END IF
    '      richiesta ripetizione calcolo
    CLS
    PRINT "Vuoi ripetere il calcolo (SI O NO) ";
    INPUT R$
    R$ = UCASE$(R$)
    IF R$ = "SI" THEN UH = 2: GOTO 400
    '      fine
    CLS
    PRINT "FINE ELABORAZIONE"
    CLOSE #2
    IF NDiag = 3 THEN CLOSE #3
    END
    '
990 '       PRIMA PAGINA - indicazioni sui files
1000 CLS
1010 RESTORE 1500
1020 GOSUB 7000
1030 GOSUB 7200
1040 GOSUB 7500
1050 GOSUB 8000
1060 UJ = 1
1070 GOSUB 7650: I$ = UCASE$(UD$)
1080 GOSUB 7650: FI$ = UD$
1090 GOSUB 7650: O$ = UCASE$(UD$)
1100 GOSUB 7650: FO$ = UD$
1110 VH = 1
1120 IF I$ <> "SI" THEN 1280
1130 '      lettura valori da disco
1140 OPEN "I", #1, FI$
1150 INPUT #1, IT$, IZ, EL
1160 FOR I = 1 TO IZ
1170    INPUT #1, DL(I), B1(I), H1(I), B2(I), H2(I), Q(I)
1180 NEXT I
1190 FOR I = 1 TO IZ + 1
1200    INPUT #1, MN(I)
1210 NEXT I
1220 CLOSE #1
1230 VH = 5
1240 IG = IZ
1250 IQ = IZ
1260 IM = IZ + 1
1270 '
1280 RETURN
1490 '
1500 DATA 4
1510 DATA 2,51,2,4,51,10,8,51,2,10,51,10
1520 DATA 5
1530 DATA 2,2,vuoi modificare valori memorizzati ?  (SI o NO)
1540 DATA 4,2,"se SI :   in quale file ?"
1550 DATA 8,2,vuoi memorizzare i dati sul disco ?   (SI o NO)
1560 DATA 10,2,"se SI :   in quale file ?"
1570 DATA 25,76,pag.1
1980 '
1990 '      SECONDA PAGINA - numero di campate
2000 CLS
2010 RESTORE 2500
2020 GOSUB 7000
2030 GOSUB 7200
2040 IF MI = 1 THEN RESTORE 2550 ELSE RESTORE 2560
2050 GOSUB 7200
2060 GOSUB 7500
2070 IF VH < UH THEN 2140
2080 '      visualizzazione valori precedenti
2090    UJ = 1
2100    UD = IZ: GOSUB 7700
2110    UD = EL: GOSUB 7700
2120    UD$ = IT$: GOSUB 7725
2130 '      assegnazione nuovi valori
2140 GOSUB 8000
2150 UJ = 1
2160 GOSUB 7650: IZ = UD
2170 GOSUB 7650: EL = UD
2180 GOSUB 7650: IT$ = UD$
2190 IF VH < UH THEN VH = UH
2200 '
2210 RETURN
2490 '
2500 DATA 3
2510 DATA 2,26,2,5,26,7,10,16,60
2520 DATA 4
2530 DATA 2,2,numero di campate,5,2,modulo di elasticita',10,2,intestazione
2540 DATA 25,76,pag.2
2550 DATA 1,5,34,kg/cm2
2560 DATA 1,5,34,N/mm2
2980 '
2990 '      TERZA PAGINA - dati geometrici
3000 CLS
3010 RESTORE 3500
3020 UT = IZ
3030 GOSUB 7100
3040 GOSUB 7200
3050 GOSUB 7300
3060 UA = 1
3070 GOSUB 7400
3080 GOSUB 7500
3090 '      visualizzazione valori precedenti o di default
3100 UJ = 1
3110 FOR I = 1 TO IZ
3120    IF I > IG THEN 3180
3130       UD = DL(I): GOSUB 7700
3140       UD = B1(I): GOSUB 7700
3150       UD = H1(I): GOSUB 7700
3160       UD = B2(I): GOSUB 7700
3170       UD = H2(I): GOSUB 7700
3180 NEXT I
3190 '      assegnazione nuovi valori
3200 GOSUB 8000
3210 UJ = 1
3220 FOR I = 1 TO IZ
3230    GOSUB 7650: DL(I) = UD
3240    GOSUB 7650: B1(I) = UD
3250    GOSUB 7650: H1(I) = UD
3260    GOSUB 7650: B2(I) = UD
3270    GOSUB 7650: H2(I) = UD
3280 NEXT I
3290 IF VH < UH THEN VH = UH
3300 IF IG < IZ THEN IG = IZ
3310 '
3320 RETURN
3490 '
3500 DATA 5,5
3510 DATA 15,7,32,5,45,5,58,5,71,5
3520 DATA 8
3530 DATA 1,26,D A T I   G E O M E T R I C I
3540 DATA 3,2,campata,3,16,luce,3,33,B1,3,46,H1,3,59,B2,3,72,H2
3550 DATA 25,76,pag.3
3560 DATA 5,23,m              cm           cm           cm           cm
3570 DATA 5,5
3980 '
3990 '      QUARTA PAGINA - carichi distribuiti
4000 IF UU = 1 THEN CLS
4010 RESTORE 4500
4020 UT = IZ
4030 GOSUB 7100
4040 GOSUB 7200
4050 UA = 1
4060 GOSUB 7400
4070 IF MI = 1 THEN RESTORE 4570 ELSE RESTORE 4580
4080 GOSUB 7300
4090 GOSUB 7500
4100 '      visualizzazione valori precedenti o di default
4110 UJ = 1
4120 FOR I = 1 TO IZ
4130    IF I > IQ THEN 4150
4140       UD = Q(I): GOSUB 7700
4150 NEXT I
4160 '      assegnazione nuovi valori
4170 GOSUB 8000
4180 UJ = 1
4190 FOR I = 1 TO IZ
4200    GOSUB 7650: Q(I) = UD
4210 NEXT I
4220 IF VH < UH THEN VH = UH
4230 IF IQ < IZ THEN IQ = IZ
4240 '
4250 RETURN
4490 '
4500 DATA 1,6
4510 DATA 16,6
4520 DATA 5
4530 DATA 1,33,C A R I C H I
4540 DATA 3,2,campata,3,14,carico uniforme,25,35,pag.4
4550 DATA 4,12,"+ se verso il basso"
4560 DATA 6,5
4570 DATA 6,23,t/m
4580 DATA 6,23,kN/m
4980 '
4990 '      QUINTA PAGINA - momenti concentrati sugli appoggi
5000 RESTORE 5500
5010 UT = IZ + 1
5020 GOSUB 7100
5030 GOSUB 7200
5040 UA = 1
5050 GOSUB 7400
5060 IF MI = 1 THEN RESTORE 5560 ELSE RESTORE 5570
5070 GOSUB 7300
5080 GOSUB 7500
5090 '      visualizzazione valori precedenti o di default
5100 UJ = 1
5110 FOR I = 1 TO IZ + 1
5120    IF I > IM THEN 5140
5130       UD = MN(I): GOSUB 7700
5140 NEXT I
5150 '      assegnazione nuovi valori
5160 GOSUB 8000
5170 UJ = 1
5180 FOR I = 1 TO IZ + 1
5190    GOSUB 7650: MN(I) = UD
5200 NEXT I
5210 IF VH < UH THEN VH = UH
5220 IF IM < IZ + 1 THEN IM = IZ + 1
5230 '
5240 RETURN
5490 '
5500 DATA 1,6
5510 DATA 57,6
5520 DATA 4
5530 DATA 3,42,appoggio,3,52,momento concentrato,25,75,pag.5
5540 DATA 4,56,"+ se orario"
5550 DATA 6,46
5560 DATA 6,64,tm
5570 DATA 6,64,kNm
5980 '
5985 '  CONTROLLO DEL VALORE DEI CAMPI
5990 '
6000 ON UH GOTO 6100, 6200, 6300, 6600, 6600
6090 '
6095 ' ---- pag.1
6100 IF UJ <> 1 AND UJ <> 3 THEN 6115
6105    GOSUB 7600
        UD$ = UCASE$(UD$)
6110    IF UD$ <> "SI" AND UD$ <> "NO" THEN GOSUB 6700
6115 GOTO 6600
6190 '
6195 ' ---- pag.2
6200 ON UJ GOTO 6220, 6240, 6600
6215 '
6220 GOSUB 7600
6225 IF UD <= 0 OR UD > 16 THEN GOSUB 6750
6230 GOTO 6600
6235 '
6240 GOSUB 7600
6245 IF UD <= 0 THEN GOSUB 6750
6250 GOTO 6600
6290 '
6295 ' ---- pag.3
6300 GOSUB 7600
6305 ON (UJ - 1) MOD 5 + 1 GOTO 6320, 6320, 6320, 6340, 6340
6315 '
6320 IF UD <= 0 THEN GOSUB 6750
6325 GOTO 6600
6335 '
6340 IF UD < 0 THEN GOSUB 6750
6345 GOTO 6600
6595 '
6600 RETURN
6695 '
6700 LOCATE 25, 2: PRINT "Devi rispondere SI o NO";
6705 GOTO 6755
6745 '
6750 LOCATE 25, 2: PRINT "Valore non ammissibile ";
6755 BEEP
6760 FOR UV = 1 TO 1500: NEXT UV
6765 LOCATE 25, 2: PRINT "                       ";
6770 UF = 0
6775 RETURN
6980 '
6985 '  LETTURA POSIZIONE E DIMENSIONE CAMPI
6990 '
7000 READ UN
7005 FOR UJ = 1 TO UN
7010    READ UR(UJ), UC(UJ), UL(UJ)
7015 NEXT UJ
7020 UM = 1
7025 RETURN
7080 '
7085 '  LETTURA POSIZIONE E DIMENSIONE CAMPI  per tabelle
7090 '
7100 READ UM, UR
7105 UN = UT * UM
7110 FOR UV = 1 TO UM
7115    READ UC, UL
7120    FOR UJ = 0 TO UN - UM STEP UM
7125       UR(UJ + UV) = UR + UJ / UM
7130       UC(UJ + UV) = UC
7135       UL(UJ + UV) = UL
7140    NEXT UJ
7145 NEXT UV
7150 RETURN
7180 '
7185 '  LETTURA E VISUALIZZAZIONE SCRITTE
7190 '
7200 READ US
7205 FOR UV = 1 TO US
7210    READ UR, UC, US$
7215    LOCATE UR, UC
7220    PRINT US$;
7225 NEXT UV
7230 RETURN
7280 '
7285 '  LETTURA E VISUALIZZAZIONE SCRITTE RIPETITIVE  per tabelle
7290 '
7300 READ UR, UC, US$
7305 FOR UV = 0 TO UT - 1
7310    LOCATE UR + UV, UC
7315    PRINT US$;
7320 NEXT UV
7325 RETURN
7380 '
7385 '  VISUALIZZAZIONE INDICI  per tabelle
7390 '
7400 READ UR, UC
7405 FOR UV = 0 TO UT - 1
7410    LOCATE UR + UV, UC
7415    PRINT UA + UV
7420 NEXT UV
7425 RETURN
7480 '
7485 '  VISUALIZZAZIONE FONDO CAMPO
7490 '
7500 COLOR 0, 15
7505 FOR UJ = 1 TO UN
7510    FOR UV = 0 TO UL(UJ) - 1
7515       LOCATE UR(UJ), UC(UJ) + UV
7520       PRINT " "
7525    NEXT UV
7530 NEXT UJ
7535 COLOR 7, 0
7540 RETURN
7580 '
7585 '  LETTURA DI UN VALORE DA UN CAMPO DEL VIDEO
7590 '
7600 UG = UJ
7605 GOSUB 8800
7610 UD = VAL(UD$)
7615 RETURN
7645 '
7650 GOSUB 7600
7655 UJ = UJ + 1
7660 RETURN
7680 '
7685 '  SCRITTURA DI UN VALORE SU UN CAMPO DEL VIDEO
7690 ' 
7700 UD$ = STR$(UD)
7705 IF LEFT$(UD$, 1) = " " THEN UD$ = RIGHT$(UD$, LEN(UD$) - 1)
7710 FOR UV = LEN(UD$) + 1 TO UL(UJ): UD$ = UD$ + " ": NEXT UV
7720 '
7725 LOCATE UR(UJ), UC(UJ)
7730 COLOR 0, 15
7735 PRINT UD$
7740 COLOR 7, 0
7745 UJ = UJ + 1
7750 RETURN
7780 '
7785 '  DIMENSIONAMENTO VARIABILI E DEFINIZIONE CODICI DI USCITA
7790 '
7800 '
7805 UF(1) = 13
7810 UF(2) = -72
7815 UF(3) = -71
7820 UF(4) = -81
7825 UF(5) = -73
7830 RETURN
7980 '
7985 '  GESTIONE DI PIU' CAMPI
7990 '
7995 '      definisce valori iniziali :
8000 UJ = 1
8005 UU = 0
8035 '      preleva il valore del campo precedente :
8040 UG = (UJ + UN - UM - 1) MOD UN + 1
8045 GOSUB 8800
8050 UP$ = UD$
8055 '      definisce riga, colonna, lunghezza del campo in esame :
8060 UR = UR(UJ)
8065 UC = UC(UJ)
8070 UL = UL(UJ)
8075 '      gestione del singolo campo : 
8080 GOSUB 9000
8085 '      controllo del valore del campo :                  
8090 GOSUB 6000
8095 '      esamina codice uscita singolo campo :
8100 IF UF = 0 THEN 8700
8105 ON UF GOTO 8200, 8300, 8400, 8500, 8600
8190 '
8195 '      passa al campo successivo :
8200 UJ = UJ MOD UN + 1
8205 GOTO 8700
8290 '
8295 '      passa al campo precedente :
8300 UJ = (UJ + UN - 2) MOD UN + 1
8305 GOTO 8700
8390 '
8395 '      passa al primo campo della pagina :
8400 UJ = 1
8405 GOTO 8700
8490 '
8495 '      passa alla pagina successiva :
8500 UU = 1
8505 GOTO 8700
8590 '
8595 '      passa alla pagina precedente :
8600 UU = -1
8605 GOTO 8700
8690 '
8695 '      fine individuazione campo successivo :
8700 IF UU = 0 THEN 8040
8705 RETURN
8780 '
8785 '  LETTURA DI UNA STRINGA DAL VIDEO
8790 '
8800 UD$ = ""
8805 FOR UV = 0 TO UL(UG) - 1
8810    UC$ = CHR$(SCREEN(UR(UG), UC(UG) + UV))
8815    UD$ = UD$ + UC$
8820 NEXT UV
8825 RETURN
8980 '              
8985 '  GESTIONE DEL SINGOLO CAMPO DATI  
8990 '                                
8995 '      definizione valori iniziali :
9000 UP = 0
9005 UI = 0
9010 UF = 0
9015 COLOR 0, 15
9045 '      visualizza il cursore :
9050 GOSUB 9800
9055 '      aspetta che sia premuto un tasto :
9060 UK$ = INKEY$
9065 IF UK$ = "" THEN 9060
9070 UK = ASC(UK$)
9075 IF UK = 0 THEN UK = -ASC(RIGHT$(UK$, 1))
9080 '      fa scomparire il cursore :
9085 GOSUB 9850
9095 '      individua il tasto premuto :
9100 FOR UV = 1 TO 5
9105    IF UK = UF(UV) THEN 9200
9110 NEXT UV
9115 IF UK = 34 THEN 9250
9120 IF UK > 31 AND UK < 128 THEN 9300
9125 IF UK = -77 THEN 9400
9130 IF UK = -75 THEN 9450
9135 IF UK = 8 THEN 9500
9140 IF UK = -83 THEN 9550
9145 IF UK = -82 THEN 9650
9150 GOSUB 9900
9155 GOTO 9700
9190 '
9195 '      uscita dal campo :
9200 UF = UV
9205 IF UP = 0 OR UP = UL THEN 9700
9210 FOR UV = UP TO UL - 1
9215    LOCATE UR, UC + UV
9220    PRINT " "
9225 NEXT UV
9230 GOTO 9700
9240 '
9245 '      virgolette :
9250 IF LEN(UP$) <> UL THEN GOSUB 9900: GOTO 9700
9255 LOCATE UR, UC
9260 PRINT UP$
9265 UP = 0
9270 UI = 0
9280 UF = 1'  se si vuole passare automaticamente al campo successivo
9285 GOTO 9700
9290 '
9295 '      carattere :
9300 IF UP = UL THEN GOSUB 9900: GOTO 9700
9305 IF UI = 0 THEN 9335
9310 FOR UV = UL - 2 TO UP STEP -1
9315    UC$ = CHR$(SCREEN(UR, UC + UV))
9320    LOCATE UR, UC + UV + 1
9325    PRINT UC$
9330 NEXT UV
9335 LOCATE UR, UC + UP
9340 PRINT UK$
9345 UP = UP + 1
9350 GOTO 9700
9390 '
9395 '      avanza il cursore :
9400 IF UP = UL THEN GOSUB 9900 ELSE UP = UP + 1
9405 UI = 0
9410 GOTO 9700
9440 '
9445 '      indietreggia il cursore :
9450 IF UP = 0 THEN GOSUB 9900 ELSE UP = UP - 1
9455 UI = O
9460 GOTO 9700
9490 '
9495 '      backspace :
9500 IF UP = 0 THEN GOSUB 9900: GOTO 9700
9502 FOR UV = UP - 1 TO UL - 2
9504    UC$ = CHR$(SCREEN(UR, UC + UV + 1))
9506    LOCATE UR, UC + UV
9508    PRINT UC$
9510 NEXT UV
9515 LOCATE UR, UC + UL - 1
9520 PRINT " "
9525 UP = UP - 1
9530 UI = 0
9535 GOTO 9700
9540 '
9545 '      delete :
9550 IF UP = UL THEN GOSUB 9900: GOTO 9700
9555 FOR UV = UP TO UL - 2
9560    UC$ = CHR$(SCREEN(UR, UC + UV + 1))
9565    LOCATE UR, UC + UV
9570    PRINT UC$
9575 NEXT UV
9580 LOCATE UR, UC + UL - 1
9585 PRINT " "
9590 UI = 0
9595 GOTO 9700
9640 '
9645 '      insert :
9650 UI = 1 - UI
9655 GOTO 9700
9690 '
9695 '      fine operazioni sul tasto :
9700 IF UF = 0 THEN 9050
9705 COLOR 7, 0
9710 RETURN
9790 '
9795 '      visualizza il cursore :
9800 IF UI = 0 THEN LOCATE UR, UC + UP, 1, 6, 7 ELSE LOCATE UR, UC + UP, 1, 3, 7
9805 RETURN
9840 '   
9845 '      annulla il cursore :         
9850 LOCATE UR, UC + UP, 0
9855 RETURN
9890 '
9895 '      segnalazione di errore :
9900 SOUND 415.35, 2.18
9905 SOUND 349.23, 2.64
9910 RETURN
9980 '
9990 '      MEMORIZZAZIONE VALORI SU DISCO
10000 OPEN "O", #1, FO$
10010 WRITE #1, IT$, IZ, EL
10020 FOR I = 1 TO IZ
10030    WRITE #1, DL(I), B1(I), H1(I), B2(I), H2(I), Q(I)
10040 NEXT I
10050 FOR I = 1 TO IZ + 1
10060    WRITE #1, MN(I)
10070 NEXT I
10080 CLOSE #1
10090 '
10100 RETURN
10960 '
10970 '      RISOLUZIONE DELLO SCHEMA
10980 '
10990 '      adatta EL alle unita' di misura di calcolo (t/m2 O kN/m2)
11000 IF MI = 1 THEN E = EL * 10 ELSE E = EL * 1000
11010 '      calcola il momento d'inerzia e l'indice di rigidezza
11020 FOR I = 1 TO IZ
11030    B1 = B1(I) / 100
11040    H1 = H1(I) / 100
11050    B2 = B2(I) / 100
11060    H2 = H2(I) / 100
11070    A = B1 * H1 + 2 * B2 * H2
11080    S = B1 * H1 ^ 2 / 2 + B2 * H2 ^ 2
11090    X = S / A
11100    ZI(I) = B1 * H1 ^ 3 / 3 + 2 * B2 * H2 ^ 3 / 3 - A * X ^ 2
11110    W(I) = E * ZI(I) / DL(I)
11120 NEXT I
11130 '      calcola i momenti d'incastro perfetto
11140 FOR I = 1 TO IZ
11150    MD(I) = Q(I) * DL(I) ^ 2 / 12
11160    MS(I) = -(MD(I))
11170 NEXT I
11180 '      risoluzione dello schema
11190 A(1) = 4 * W(1)
11200 B(1) = 2 * W(1)
11210 C(1) = MN(1) - MS(1)
11220 FOR I = 2 TO IZ + 1
11230    A(I) = 4 * W(I - 1)
11240    C(I) = MN(I) - MD(I - 1)
11250    IF I = IZ + 1 THEN 11290
11260       A(I) = A(I) + 4 * W(I)
11270       B(I) = 2 * W(I)
11280       C(I) = C(I) - MS(I)
11290    A(I) = A(I) - B(I - 1) ^ 2 / A(I - 1)
11300    C(I) = C(I) - B(I - 1) * C(I - 1) / A(I - 1)
11310 NEXT I
11320 C(IZ + 1) = C(IZ + 1) / A(IZ + 1)
11330 FOR I = IZ TO 1 STEP -1
11340    C(I) = (C(I) - B(I) * C(I + 1)) / A(I)
11350 NEXT I
11360 '
11370 '      determina momento e taglio agli estremi delle travi
11380 FOR I = 1 TO IZ
11390    MS(I) = MS(I) + (4 * C(I) + 2 * C(I + 1)) * W(I)
11400    MD(I) = -(MD(I) + (4 * C(I + 1) + 2 * C(I)) * W(I))
11410    TS(I) = (MD(I) - MS(I)) / DL(I) + Q(I) * DL(I) / 2
11420    TD(I) = (MD(I) - MS(I)) / DL(I) - Q(I) * DL(I) / 2
11430 NEXT I
11440 '
11450 RETURN
11960 '
11970 '      STAMPA DATI
11980 '
11990 '      stampa intestazione lavoro
12000 IF FOut$ = "PRN" OR FOut$ = "LPT1" THEN
         WIDTH LPRINT 96
         PRINT #2, CHR$(27) + "M"
      END IF
12004 PRINT #2, TAB(11); IT$
12010 PRINT #2,
12020 PRINT #2,
12030 '      stampa descrizione sintetica del programma
12040 PRINT #2, "RISOLUZIONE DI UNO SCHEMA DI TRAVE CONTINUA"
12050 PRINT #2,
12060 PRINT #2, "Schema geometrico:       aste rettilinee a sezione costante, rettangolare o a T."
12070 PRINT #2, "Vincoli esterni:         appoggi fissi."
12080 PRINT #2, "Tipi di carico ammessi:  carichi uniformemente distribuiti sulle travi (positivi"
12090 PRINT #2, "                              se diretti verso il basso);"
12100 PRINT #2, "                         momenti concentrati sugli appoggi (positivi se orari)."
12110 PRINT #2,
12120 PRINT #2, "Convenzione dei segni per i risultati :"
12130 PRINT #2, "     rotazione:          positiva se oraria;"
12140 PRINT #2, "     momento flettente:  positivo se tende le fibre inferiori;"
12150 PRINT #2, "     taglio:             positivo se diretto verso il basso,  come azione  sulla"
12160 PRINT #2, "                              faccia di normale uscente verso destra."
12170 PRINT #2,
12180 PRINT #2,
12190 '      stampa dati geometrici ed elastici
12200 PRINT #2, "DATI GEOMETRICI ED ELASTICI"
12210 PRINT #2,
12220 PRINT #2, "campata     luce      larghezza    altezza    sporgenza   spessore     momento"
12230 PRINT #2, "                        anima      totale        ala         ala      d'inerzia"
12240 A$ = "  ##      ###.## m   ####.# cm   ####.# cm   ####.# cm   ####.# cm  ##.###### m4"
12250 FOR I = 1 TO IZ
12260    PRINT #2, USING A$; I, DL(I), B1(I), H1(I), B2(I), H2(I), ZI(I)
12270 NEXT I
12280 PRINT #2,
12290 IF MI = 1 THEN A$ = "Modulo di elasticita'     E = ####### kg/cm2"
12300 IF MI <> 1 THEN A$ = "Modulo di elasticita'     E = ###### N/mm2"
12310 PRINT #2, USING A$; EL
12320 PRINT #2,
12330 PRINT #2,
12340 PRINT #2, "CARICHI UNIFORMI"; TAB(41); "MOMENTI CONCENTRATI"
12350 PRINT #2,
12360 PRINT #2, "campata      carico"; TAB(41); "appoggio     momento"
12370 IF MI = 1 THEN A$ = "  ##       ###.## t/m                    ##        ###.## tm"
12380 IF MI <> 1 THEN A$ = "  ##       ####.# kN/m                    ##        ####.# kNm"
12390 FOR I = 1 TO IZ
12400    PRINT #2, USING A$; I, Q(I), I, MN(I)
12410 NEXT I
12420 IF MI = 1 THEN A$ = "                                         ##        ###.## tm"
12430 IF MI <> 1 THEN A$ = "                                          ##        ####.# kNm"
12440 PRINT #2, USING A$; I, MN(I)
12450 PRINT #2,
12460 PRINT #2,
12470 '
12480 RETURN
12960 '
12970 '      STAMPA RISULTATI
12980 '
12990 '      stampa rotazioni
13000 PRINT #2, "ROTAZIONE DEI NODI"
13010 PRINT #2,
13020 PRINT #2, "   nodo     rotazione"
13030 FOR I = 1 TO IZ + 1
13040    PRINT #2, USING "    ##     +#.###^^^^"; I, C(I)
13050 NEXT I
13060 PRINT #2,
13070 '      stampa caratteristiche di sollecitazione
13080 PRINT #2, "CARATTERISTICHE DI SOLLECITAZIONE"
13090 PRINT #2,
13100 IF MI = 1 THEN A$ = "   ###.## tm" ELSE A$ = "  ####.# kNm"
13110 IF MI = 1 THEN B$ = "   ###.## t " ELSE B$ = "  ####.# kN "
13120 FOR I = 1 TO IZ
13130    PRINT #2, "   Campata "; I
13140    PRINT #2,
13150    FOR J = 1 TO 5
13160       X(J) = J * DL(I) / 5
13170       T(J) = TS(I) - Q(I) * X(J)
13180       M(J) = MS(I) + TS(I) * X(J) - Q(I) * X(J) ^ 2 / 2
13190    NEXT J
13200    PRINT #2, "ascissa";
13210    PRINT #2, USING "   ###.## m "; 0, X(1), X(2), X(3), X(4), X(5)
13220    PRINT #2, "momento";
13230    PRINT #2, USING A$; MS(I), M(1), M(2), M(3), M(4), M(5)
13240    PRINT #2, "taglio ";
13250    PRINT #2, USING B$; TS(I), T(1), T(2), T(3), T(4), T(5)
13260    PRINT #2,
13270 NEXT I
13280 '
13290 RETURN
13960 '
13970 '      VISUALIZZAZIONE DIAGRAMMI
13980 '
13990 '      dimensioni reali schermo
14000 SCREEN 2
14005 FX = .212
14010 FY = .16
14020 '      calcola luce massima e lunghezza totale
14030 LM = 0
14040 LT = 0
14050 FOR I = 1 TO IZ
14060    IF LM < DL(I) THEN LM = DL(I)
14070    LT = LT + DL(I)
14080 NEXT I
14090 '      calcola momento e taglio massimo
14100 MX = 0
14110 TX = 0
14120 FOR I = 1 TO IZ
14130    IF MX < ABS(MS(I)) THEN MX = ABS(MS(I))
14140    IF MX < ABS(MD(I)) THEN MX = ABS(MD(I))
14150    V = ABS(Q(I) * DL(I) ^ 2 / 8)
14160    IF MX < V THEN MX = V
14170    IF TX < ABS(TS(I)) THEN TX = ABS(TS(I))
14180    IF TX < ABS(TD(I)) THEN TX = ABS(TD(I))
14190 NEXT I
14200 MM = MX * LT / LM * FY / FX: IF MM < MX THEN MM = MX
14210 TM = 2 * TX * LT / LM * FY / FX: IF TM < TX THEN TM = TX
14220 '      definisce la scala del disegno del momento flettente
14230 WINDOW (-.02 * LT, -MM)-(1.02 * LT, MM)
14240 '      disegna lo schema geometrico
14250 HA = MM / 25
14260 GOSUB 14800
14270 '      disegna il diagramma del momento
14280 XA = 0
14290 LINE -(XA, 0), 2
14300 FOR I = 1 TO IZ
14310    LINE -(XA, -MS(I))
14320    FOR J = 1 TO 20
14330       X = DL(I) * J / 20
14340       M = MS(I) + TS(I) * X - Q(I) * X ^ 2 / 2
14350       LINE -(XA + X, -M)
14360    NEXT J
14370    XA = XA + DL(I)
14380 NEXT I
14390 LINE -(XA, 0)
      IF DiagOut$ <> "CON" AND SCR = 2 THEN
         CALL FCOPY(SCR, 1, NDiag)
      ELSE
         IF DiagOut$ <> "CON" AND SCR <> 2 THEN
            LOCATE 1, 1
            PRINT "Impossibile inviare il diagramma all'unita` prescelta"
         END IF
         FOR V = 1 TO 7500: NEXT V
      END IF
14410 '      definisce la scala del disegno del taglio
14420 WINDOW (-.02 * LT, -TM)-(1.02 * LT, TM)
14430 '      disegna lo schema geometrico
14440 HA = TM / 25
14450 GOSUB 14800
14460 '      disegna il diagramma del taglio
14470 XA = 0
14480 LINE -(XA, 0), 2
14490 FOR I = 1 TO IZ
14500    LINE -(XA, TS(I))
14510    LINE -(XA + DL(I), TD(I))
14520    XA = XA + DL(I)
14530 NEXT I
14540 LINE -(XA, 0)
      IF DiagOut$ <> "CON" AND SCR = 2 THEN
         CALL FCOPY(SCR, 1, NDiag)
      ELSE
         IF DiagOut$ <> "CON" AND SCR <> 2 THEN
            LOCATE 1, 1
            PRINT "Impossibile inviare il diagramma all'unita` prescelta"
         END IF
         FOR V = 1 TO 7500: NEXT V
      END IF
14560 '
14570 SCREEN 0
14580 RETURN
14790 '      disegna lo schema geometrico
14800 CLS
14810 LINE (0, 0)-(LT, 0)
14820 XA = 0
14830 FOR I = 0 TO IZ
14840    IF I > 0 THEN XA = XA + DL(I)
14850    LINE (XA, 0)-(XA - LT / 50, -HA)
14860    LINE -(XA + LT / 50, -HA)
14870    LINE -(XA, 0)
14880 NEXT I
14890 RETURN
19980 '
19990 ' trave continua
19999 ' A.G. 22-11-86        rev. 01.90   vers. 1.2

